import os
from numpy import array
from scipy.stats import linregress

nmr_exp = [126.54,109.82,133.86,116.74,161.21,110.62,6.999,7.49,6.939,151.51,150.17,6.42,6.42,7.36,7.36]
nmr_c_exp = [126.54,109.82,133.86,116.74,161.21,110.62,151.51,150.17]
nmr_h_exp = [6.999,7.49,6.939,6.42,6.42,7.36,7.36]
read_elements = 1
elements = []
nmr_c = []
nmr_h = []
ref = []
slope = []
r2 = []
c_out = open('carbon.dat','w')
h_out = open('hydrogen.dat','w')
for i in range(1,8):
#for i in [1,2,3,6,7]:
    dirname = 'rmn_'+str(i)
    _ref = []
    with open(dirname+'/'+'ref-tms-nmr.log') as datafile:
        while 1:
            try:
                line = next(datafile)
                if 'Isotropic' in line:
                    words = line.split()
                    _ref.append(float(words[4]))
            except StopIteration:
                break
    ref.append([sum(_ref[1:5])/4., sum(_ref[5:17])/12.])
for j in range(1,8):
    i = j-1
#for i,j in enumerate([1,2,3,6,7]):
    dirname = 'rmn_'+str(j)
    _nmr_c = []
    _nmr_h = []
    ind = 0
    with open(dirname+'/'+'luminol-nmr.log') as datafile:
        while 1:
            try:
                line = next(datafile)
                if 'Isotropic' in line:
                    words = line.split()
                    if words[1] =='C' or words[1] == 'H':
                        if read_elements:
                            elements.append(words[1])
                        if elements[ind] == 'C':
                            _nmr_c.append(ref[i][0] - float(words[4]))
                        elif elements[ind] == 'H':
                            _nmr_h.append(ref[i][1] - float(words[4]))
                        ind += 1
            except StopIteration:
                break
    read_elements = 0
    nmr_c.append(_nmr_c)
    nmr_h.append(_nmr_h)
nmr_c = array(nmr_c)
nmr_h = array(nmr_h)
for i in range(nmr_c.shape[1]):
    line = ''
    for _dat in nmr_c[:,i]:
        line += ' %10.4f ' % (_dat)
    line += ' %10.4f ' % (nmr_c_exp[i])
    line += '\n'
    c_out.write(line)
line_slope = ''
line_r2 = ''
for i in range(nmr_c.shape[0]):
    slope, intercept, r_value, p_value, std_err = linregress(nmr_c[i],nmr_c_exp)
    line_slope += ' %10.4f ' % (slope)
    line_r2 += ' %10.4f ' % (r_value**2)
print('slope for carbon linear fit:  '+line_slope)
print('R2 for carbon linear fit:     '+line_r2)

for i in range(nmr_h.shape[1]):
    line = ''
    for _dat in nmr_h[:,i]:
        line += ' %10.4f ' % (_dat)
    line += ' %10.4f ' % (nmr_h_exp[i])
    line += '\n'
    h_out.write(line)
line_slope = ''
line_r2 = ''
for i in range(nmr_h.shape[0]):
    slope, intercept, r_value, p_value, std_err = linregress(nmr_h[i],nmr_h_exp)
    line_slope += ' %10.4f ' % (slope)
    line_r2 += ' %10.4f ' % (r_value**2)
print('slope for hydrogen linear fit:'+line_slope)
print('R2 for hydrogen linear fit:   '+line_r2)
#for i,e in enumerate(elements):
#    line = e
#    for dat in nmr[:,i]:
#        line += ' %10.4f ' % (dat)
#    line += ' %10.4f ' % (nmr_exp[i])
#    line += '\n'
#    if e == 'C':
#        c_out.write(line)
#    elif e == 'H':
#        h_out.write(line)

